// Forlix SrcDS MRRPatch
// http://forlix.org/, df@forlix.org
//
// Copyright (c) 2010-2014 Dominik Friedrichs

#ifndef SRCDS_MRRPATCH_H
#define SRCDS_MRRPATCH_H

#include <windows.h>
#include <time.h>
#include <stdio.h>

#include <ISmmPlugin.h>
#include <iplayerinfo.h>
#include <igameevents.h>

#include "CSigScan.h"
#include "CMemPatch.h"

#include "tier0/vcrmode.h"
#include "filesystem.h"
#include "mrecipientfilter.h"
#include "bitbuf.h"

#include "engine_wrappers.h"

#if defined WIN32 && !defined snprintf
#define snprintf _snprintf
#endif

// Misc.cpp
const char *TimeStampStr();

class Forlix_SrcDS_MRRPatch :
  public ISmmPlugin, 
  public IMetamodListener, 
  public IConCommandBaseAccessor
{
public:
	bool Load(PluginId id, ISmmAPI *ismm, char *error, size_t maxlen, bool late);
	bool Unload(char *error, size_t maxlen);
  void OnVSPListening(IServerPluginCallbacks *iface);

  void Hook_GameFrame(bool simulating);
  void Hook_ServerActivate(edict_t *pEdictList, int edictCount, int clientMax);
	bool Hook_LevelInit(const char *pMapName,
                      char const *pMapEntities,
                      char const *pOldLevel,
                      char const *pLandmarkName,
                      bool loadGame,
                      bool background);
  void Hook_LevelShutdown();

public: //IConCommandBaseAccessor
  bool RegisterConCommandBase(ConCommandBase *pVar);

public:
	const char *GetAuthor();
	const char *GetName();
	const char *GetDescription();
	const char *GetURL();
	const char *GetLicense();
	const char *GetVersion();
	const char *GetDate();
	const char *GetLogTag();
};

PLUGIN_GLOBALVARS();

extern Forlix_SrcDS_MRRPatch g_Forlix_SrcDS_MRRPatch;

#endif // SRCDS_MRRPATCH_H
